<p class="title__table">Bảng thông tin</p>

<p-table [value]="listData" editMode="row" dataKey="id" styleClass="p-datatable-striped custom-table w-min text-center">
    <ng-template pTemplate="header">
        <tr>
            <th rowspan="2" style="width: 10%;">Action</th>
            <th rowspan="2" style="width: 17%;">Name</th>
            <th rowspan="2" style="width: 8%;">Age</th>
            <th colspan="4" style="width: 50%;">Information</th>
            <th rowspan="2" style="width: 20%;">Registered</th>
        </tr>
        <tr>
            <th>Gender</th>
            <th style="width: 8%;">Eyes color</th>
            <th>Phone</th>
            <th>Address</th>
        </tr>
    </ng-template>
    <ng-template pTemplate="body" let-data let-editing="editing" let-ri="rowIndex">
        <tr [pEditableRow]="data" [className]="handleCheckNullData(data)? 'bg-red-100': ''">
            <td class="flex justify-content-center align-items-center border-none bg-white p-4">

                <button *ngIf="!editing" pButton [text]="true" [disabled]="disableButton"
                    class="pi pi-trash text-lg text-cyan-500 text-orange-500 cursor-pointer"
                    (click)="hanldeDeleteDataRow(data, ri)"></button>

                <button *ngIf="!editing" pButton [text]="true" [disabled]="disableButton" pInitEditableRow pButton
                    (click)="onRowEditInit(data)"
                    class="pi pi-pen-to-square text-lg text-orange-500 cursor-pointer"></button>

                <button *ngIf="editing" pButton [text]="true" pSaveEditableRow (click)="onRowEditSave(data, ri)"
                    class="pi pi-check text-green-500 cursor-pointer"></button>

                <button *ngIf="editing" pButton [text]="true" pCancelEditableRow (click)="onRowEditCancel(data, ri)"
                    class="pi pi-times text-red-500 cursor-pointer"></button>

            </td>
            <td [className]="handleCheckNullValue(data.name)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <input pInputText type="text" [(ngModel)]="data.name">
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.name}}
                        <div [className]="handleCheckNullValue(data.name)? 'pi pi-times-circle text-red-500': ''"></div>
                    </ng-template>
                </p-cellEditor>
            </td>
            <td [className]="handleCheckNullValue(data.age)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <input pInputText type="text" [(ngModel)]="data.age">
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.age}}
                        <div [className]="handleCheckNullValue(data.age)? 'pi pi-times-circle text-red-500': ''"></div>
                    </ng-template>
                </p-cellEditor>
            </td>
            <td [className]="handleCheckNullValue(data.gender)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <input pInputText type="text" [(ngModel)]="data.gender">
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.gender}}
                        <div [className]="handleCheckNullValue(data.gender)? 'pi pi-times-circle text-red-500': ''">
                        </div>
                    </ng-template>
                </p-cellEditor>
            </td>
            <td [className]="handleCheckNullValue(data.eyeColor)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <input pInputText type="text" [(ngModel)]="data.eyeColor">
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.eyeColor}}
                        <div [className]="handleCheckNullValue(data.eyeColor)? 'pi pi-times-circle text-red-500': ''">
                        </div>
                    </ng-template>
                </p-cellEditor>
            </td>
            <td [className]="handleCheckNullValue(data.phone)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <input pInputText type="text" [(ngModel)]="data.phone">
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.phone}}
                        <div [className]="handleCheckNullValue(data.phone)? 'pi pi-times-circle text-red-500': ''">
                        </div>
                    </ng-template>
                </p-cellEditor>
            </td>
            <td [className]="handleCheckNullValue(data.address)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <input pInputText type="text" [(ngModel)]="data.address">
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.address}}
                        <div [className]="handleCheckNullValue(data.address)? 'pi pi-times-circle text-red-500': ''">
                        </div>
                    </ng-template>
                </p-cellEditor>
            </td>
            <td [className]="handleCheckNullValue(data.registered)?'text-center':''">
                <p-cellEditor>
                    <ng-template pTemplate="input">
                        <!-- <input pInputText type="text" [(ngModel)]="data.registered"> -->
                        <p-calendar [(ngModel)]="data.registered" dateFormat="dd/mm/yy" [iconDisplay]="'input'"
                            [showIcon]="true" appendTo="body" tooltipPosition="top" inputId="icondisplay"></p-calendar>
                    </ng-template>
                    <ng-template pTemplate="output">
                        {{data.registered}}
                        <div [className]="handleCheckNullValue(data.registered)? 'pi pi-times-circle text-red-500': ''">
                        </div>
                    </ng-template>
                </p-cellEditor>
            </td>

        </tr>
    </ng-template>

    <ng-template pTemplate="footer">
        <tr [style]="displayNone ? 'display: none': '' ">
            <td class="text-center">
                <button pButton [text]="true" class="pi pi-sync text-primary text-lg"
                    (click)="handleResetStateItem()"></button>
                <button pButton [text]="true" [disabled]="handleCheckNullAdd()" class="pi pi-save text-green-500 text-lg"
                    (click)="handleUAddDataRow()"></button>
            </td>
            <td>
                <form [formGroup]="myForm">
                    <input type="text" pInputText placeholder="Name" formControlName="name">
                </form>
            </td>
            <td>
                <form [formGroup]="myForm">
                    <input type="text" pInputText placeholder="Age" formControlName="age">
                </form>
            </td>
            <td>
                <form [formGroup]="myForm">
                    <p-dropdown [options]="genderArr" appendTo="body" placeholder="Gender" formControlName="gender"
                        [style]="{'width':'100%'}"></p-dropdown>
                </form>
            </td>
            <td>
                <form [formGroup]="myForm">
                    <p-dropdown [options]="eyeColorArr" appendTo="body" placeholder="Eyes Color" formControlName="eyeColor"
                    [style]="{'width':'100%'}"></p-dropdown>
                </form>
            </td>
            <td>
                <form [formGroup]="myForm">
                    <input type="text" pInputText placeholder="Phone" formControlName="phone">
                </form>
            </td>
            <td>
                <form [formGroup]="myForm">
                <input type="text" pInputText placeholder="Address" formControlName="address">
                </form>
            </td>
            <td>
                <div class="flex-auto">
                    <p-calendar [(ngModel)]="item.registered" dateFormat="dd/mm/yy" [iconDisplay]="'input'"
                        [showIcon]="true" appendTo="body" tooltipPosition="top" inputId="icondisplay"
                        (ngModelChange)="onDateChange($event)"></p-calendar>
                </div>
            </td>
        </tr>
        <tr>
            <td class="bg-white border-none"></td>
            <td class="bg-white border-none">
                <div *ngIf="myForm.get('name')?.errors && myForm.get('name')?.touched" class="text-red-500 font-medium">
                    Tên không được để trống!
                </div>
            </td>
            <td class="bg-white border-none">
                <div *ngIf="myForm.get('age')?.errors && myForm.get('age')?.touched" class="text-red-500 font-medium">
                    Tuổi không được để trống
                </div>
            </td>
            <td class="bg-white border-none">
                <div *ngIf="myForm.get('gender')?.errors && myForm.get('gender')?.touched" class="text-red-500 font-medium">
                    Giới tính không được để trống!
                </div>
            </td>
            <td class="bg-white border-none">
                <div *ngIf="myForm.get('eyeColor')?.errors && myForm.get('eyeColor')?.touched" class="text-red-500 font-medium">
                    Màu mắt không được để trống!
                </div>
            </td>
            <td class="bg-white border-none">
                <div *ngIf="myForm.get('phone')?.errors && myForm.get('phone')?.touched" class="text-red-500 font-medium">
                    Số điện thoại không được để trống
                </div>
            </td>
            <td class="bg-white border-none">
                <div *ngIf="myForm.get('address')?.errors && myForm.get('address')?.touched" class="text-red-500 font-medium">
                    Địa chỉ không được để trống!
                </div>
            </td>
        </tr>
    </ng-template>
</p-table>

<div class="w-max p-2 mt-2" (click)="onClickAdd()">
    <span class="pi pi-plus-circle text-orange-500 mr-3"></span>
    <span class="text-orange-500">Thêm mới</span>
</div>
